// Copyright 2018 by Robert Dick.
// All rights reserved.

#include <typeinfo>
#include "AssocVec.h"

#include <iostream>

namespace rstd {
using namespace std;

/*###########################################################################*/
void AssocVec_test() {
	AssocVec<int> fred(10, 0);
	fred(2, 5) = 1;
	Rassert(fred(5, 2) && fred(2, 5) && ! fred(4, 4));

	{
		AssocVec<double> gene;
		gene.resize(5);
		gene.erase(2);
	}

	fred.print_to_default(cout);
	AssocVec<int> gene(3, 0);

	gene(1, 2) = 2;
	gene(0, 2) = 2;
	gene(0, 1) = 3;

	gene.resize(5, 12);

	MAP(i, gene.size()) {
		MAP(j, gene.size()) {
			cout << gene(i, j) << " ";
		}
		cout << "\n";
	}

	gene.resize(3, 15);
	cout << "====================\n";
	cout << gene.size() << "\n";

	MAP(i, gene.size()) {
		MAP(j, gene.size()) {
			cout << gene(i, j) << " ";
		}
		cout << "\n";
	}
}

}
