// Copyright 2018 by Robert Dick.
// All rights reserved.

#include "RefAdapter.h"

#include <algorithm>
#include <iostream>
#include <set>

#include "RVector.h"

namespace rstd {
using namespace std;

/*===========================================================================*/
void RefAdapter_test() {
	RVector<int *> vec;
	int a = 0;
	int b = 1;
	int c = 2;

	vec.push_back(& a);
	vec.push_back(& b);
	vec.push_back(& c);

	RefAdapter<RVector<int *> > adapt(vec);

	cout << adapt[0] << "\n";
	cout << adapt[1] << "\n";
	cout << adapt[2] << "\n";

	RefAdapter<RVector<int *> >::iterator w = adapt.begin();
	while (w != adapt.end()) {
		cout << * w << "\n";
		w++;
	}

	copy(adapt.begin(), adapt.end(), ostream_iterator<int>(cout, "\n"));

	int ** i1 = 0;
	ref_iterator<int **> ri1(i1);

	RVector<int *>::iterator i2;
	ref_iterator<RVector<int *>::iterator> ri2(i2);

	set<int *>::iterator i3;
	const ref_iterator<set<int *>::iterator> ri3(i3);
	set<int *>::iterator i4(i3);
	set<int *>::const_iterator i5(i3);
}

}
